"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = __importStar(require("react"));
var constants_1 = require("../constants");
var isNode = require('./isNode').isNode;
//const isNodeEnv = isNode();
/**
 *
 * @param {React Component} Component   The Component to be wrapped and later hydrated
 * @param {string}          cid         The component identifier. Referenced in your client hydration script. Eg "Button".
 *                                      In your client hydration script you'll have a component object, eg
 *                                      import SpecialButton from '../SpecialButton'
 *                                      cids = { "Button":  SpecialButton}
 *                                      So a cid value of "Button" would render the SpecialButton component.
 *                                      (normally the cid and component name should be the same. They're different here to illustrate they can be.)
 *
 */
var withHydration = function (Component, cid) { return function (props) {
    var ssrComponent = (React.createElement(React.Fragment, null,
        React.createElement("script", { type: constants_1.HYDRATION_SCRIPT_TYPE, dangerouslySetInnerHTML: {
                __html: JSON.stringify({ cid: cid, props: props }).replace(/</g, '\\u003c')
            } }),
        React.createElement("span", null,
            React.createElement(Component, __assign({}, props)))));
    return isNode() ? ssrComponent : React.createElement(Component, __assign({}, props));
}; };
module.exports = withHydration;
